import java.awt.*;
import java.awt.event.*;
import java.sql.*;
import java.util.*;
import java.awt.List;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import java.rmi.RemoteException;

public class BrokerGUI implements ActionListener, ItemListener {
	

	
	private DatabaseHome  home;
	private Database   db;

	// ADD, DELETE, UPDATE  
	private int currentOP;
	private final static int NO_OP = -1;
	private final static int ADD_OP = 1;
	private final static int DELETE_OP = 2;
	private final static int UPDATE_OP = 3;

	// List  ڿ Token  Ʈ 
	private StringTokenizer st;

	Frame frame = new Frame("Broker GUI");

	//  ޽ Dialog
	Dialog errorDialog =	new Dialog(frame, "Error Message");
	Label errorl =				new Label();
	Button errorOKb =		new Button("OK");

	// ȭ   Panel 
	Panel PWest =					new Panel();
	Panel PWestNorth =			new Panel();
	Panel PWestNorthSub1 =		new Panel();
	Panel PWestNorthSub2 =		new Panel();
	Panel PWestCenter =			new Panel();
	Panel PWestCenterSub1 =	new Panel();
	Panel PWestCenterSub2 =	new Panel();
	Panel PWestCenterSub3 =	new Panel();
	Panel PWestSouth =			new Panel();
	Panel PEast =					new Panel();
	Panel PEastNorth =				new Panel();
	Panel PEastCenter =			new Panel();
	Panel PEastSouth =			new Panel();

	Label cusl =				new Label("Customer Information");
	Label allCusl =			new Label("All Customers");
	Label stockl2 =			new Label("Stock Portfolio");
	Label namel =			new Label("Name");
	Label ssnl =				new Label("SSN");
	Label addressl =		new Label("Address");
	Label stockl1 =			new Label("Stock Information");
	Label allStockl =			new Label("Available Stocks");
	Label stockNamel =		new Label("Stock");
	Label stockPricel =		new Label("Current Price");

	TextField nametf =		new TextField();
	TextField ssntf =			new TextField();
	TextField symboltf =	new TextField("", 15);
	TextField quatf =			new TextField("", 15);
	TextField stocktf =		new TextField();
	TextField pricetf =		new TextField();

	TextArea addressta =	new TextArea();

	List cuslist =		new List();
	List stocklist =	new List();
	List portlist =		new List();

	Button addb =			new Button("ADD");
	Button deleteb =		new Button("DELETE");
	Button updateb =	new Button("UPDATE");
	Button viewb =		new Button("VIEW");
	Button impleb =		new Button("IMPLE");
	Button cancelb =	new Button("CANCEL");
	Button buyb =			new Button("BUY");
	Button sellb =			new Button("SELL");
	Button stockb =		new Button("Stock Price");

	public BrokerGUI() {

		try{
			  
			Hashtable  env = new Hashtable();
			env.put(Context.PROVIDER_URL , "t3://127.0.0.1:7001" );
			env.put(Context.INITIAL_CONTEXT_FACTORY , "weblogic.jndi.WLInitialContextFactory" );


			Context  ctx  = new InitialContext(env);
			   Object obj  = ctx.lookup("DatabaseEJB2");
			   home = (DatabaseHome)PortableRemoteObject.narrow( obj , DatabaseHome.class );
				db = home.create();
		}catch(Exception e){
			e.printStackTrace();
		}
		createGUI();
		addListener();

		// α׷ ϸ,  Ʈ ֽ Ʈ ѷֱ
		showCustomerList();
		showStockList();

		// TextFiled ʱȭ, Enabled Set, ADD/DELETE/UPDATE/VIEW Enabled Set
		emptyText();
		textEnabled(false);
		buttonEnabled(true);

		
	}

	public void createGUI() {
		// Ʈ , ۲õ 
		cuslist.setBackground(Color.yellow);
		cuslist.setForeground(Color.blue);
		portlist.setBackground(Color.yellow);
		portlist.setForeground(Color.blue);
		stocklist.setBackground(Color.blue);
		stocklist.setForeground(Color.yellow);

		// ȭ   Ʈ 
		PWestNorthSub1.add(cusl);
		PWestNorthSub2.add(addb);
		PWestNorthSub2.add(deleteb);
		PWestNorthSub2.add(updateb);
		PWestNorthSub2.add(viewb);
		PWestNorthSub2.add(impleb);
		PWestNorthSub2.add(cancelb);

		PWestNorth.setLayout(new BorderLayout());
		PWestNorth.add(PWestNorthSub1, BorderLayout.NORTH);
		PWestNorth.add(PWestNorthSub2, BorderLayout.CENTER);

		PWestCenterSub1.setLayout(new BorderLayout());
		PWestCenterSub1.add(allCusl, BorderLayout.NORTH);
		PWestCenterSub1.add(cuslist, BorderLayout.CENTER);

		PWestCenterSub2.setLayout(new GridLayout(6, 1, 5, 5));
		PWestCenterSub2.add(namel);
		PWestCenterSub2.add(nametf);
		PWestCenterSub2.add(ssnl);
		PWestCenterSub2.add(ssntf);
		PWestCenterSub2.add(addressl);
		PWestCenterSub2.add(addressta);

		PWestCenterSub3.setLayout(new BorderLayout());
		PWestCenterSub3.add(stockl2, BorderLayout.NORTH);
		PWestCenterSub3.add(portlist, BorderLayout.CENTER);

		PWestCenter.setLayout(new GridLayout(1, 3, 5, 5));
		PWestCenter.add(PWestCenterSub1);
		PWestCenter.add(PWestCenterSub2);
		PWestCenter.add(PWestCenterSub3);

		PWestSouth.add(buyb);
		PWestSouth.add(symboltf);
		PWestSouth.add(quatf);
		PWestSouth.add(sellb);

		PWest.setLayout(new BorderLayout(5, 5));
		PWest.add(PWestNorth, BorderLayout.NORTH);
		PWest.add(PWestCenter, BorderLayout.CENTER);
		PWest.add(PWestSouth, BorderLayout.SOUTH);

		PEastNorth.add(stockl1);

		PEastCenter.setLayout(new BorderLayout());
		PEastCenter.add(allStockl, BorderLayout.NORTH);
		PEastCenter.add(stocklist, BorderLayout.CENTER);
		PEastCenter.add(stockb, BorderLayout.SOUTH);

		PEastSouth.setLayout(new GridLayout(2, 2));
		PEastSouth.add(stockNamel);
		PEastSouth.add(stocktf);
		PEastSouth.add(stockPricel);
		PEastSouth.add(pricetf);

		PEast.setLayout(new BorderLayout(5, 5));
		PEast.add(PEastNorth, BorderLayout.NORTH);
		PEast.add(PEastCenter, BorderLayout.CENTER);
		PEast.add(PEastSouth, BorderLayout.SOUTH);

		frame.setSize(800, 500);
//		frame.add(PWest, BorderLayout.WEST);
		frame.add(PWest, BorderLayout.CENTER);
		frame.add(PEast, BorderLayout.EAST);

		// Ticker Tape  ѷִ TickerTape ̱
		// ---

		frame.setLocation(200, 200);
		frame.setVisible(true);

		//  ޽ ȭ
		errorDialog.setLayout(new FlowLayout());
		errorDialog.add(errorl);
		errorDialog.add(errorOKb);
	}

	public void addListener() {
		//  
		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				System.exit(0);
			}
		});

		//  Ŭ
		addb.addActionListener(this);
		deleteb.addActionListener(this);
		updateb.addActionListener(this);
		viewb.addActionListener(this);
		impleb.addActionListener(this);
		cancelb.addActionListener(this);
		buyb.addActionListener(this);
		sellb.addActionListener(this);
		stockb.addActionListener(this);

		// Ʈ  ý
		cuslist.addItemListener(this);
		portlist.addItemListener(this);
		stocklist.addItemListener(this);

		//  ޽ ȭ 'OK'  Ŭ
		errorDialog.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				errorDialog.dispose();
			}
		});
		errorOKb.addActionListener(this);
	}

	//  ޽ ȭڸ 
	private void showErrorDialog(String errorMessage) {
		errorl.setText(errorMessage);

		errorDialog.pack();
		errorDialog.setLocation(400, 400);

		errorDialog.show();
	}

	//  Ŭ ̺Ʈ ڵ鸵
	public void actionPerformed(ActionEvent ae) {
		String buttonName = ae.getActionCommand();

		if ( buttonName.equals("ADD") ) {
			emptyText();
			textEnabled(true);
			buttonEnabled(false);

			currentOP = ADD_OP;
		} else if ( buttonName.equals("DELETE") ) {
			textEnabled(false);
			buttonEnabled(false);

			currentOP = DELETE_OP;
		} else if ( buttonName.equals("UPDATE") ) {
			textEnabled(true);
			buttonEnabled(false);

			currentOP = UPDATE_OP;
		} else if ( buttonName.equals("VIEW") ) {
			showCustomerList();
			showStockList();
		} else if ( buttonName.equals("IMPLE") ) {
			switch (currentOP) {
				case ADD_OP :
					addCustomer();
					break;
				case DELETE_OP :
					deleteCustomer();
					break;
				case UPDATE_OP :
					updateCustomer();
					break;
			}

			showCustomerList();

			emptyText();
			textEnabled(false);
			buttonEnabled(true);

			currentOP = NO_OP;
		} else if ( buttonName.equals("CANCEL") ) {
			textEnabled(false);
			buttonEnabled(true);

			currentOP = NO_OP;
		} else if ( buttonName.equals("BUY") ) {
			String ssn = ssntf.getText().trim();
			String symbol = symboltf.getText().trim();
			int quantity = Integer.parseInt(quatf.getText().trim());

			try {
				db.buyShares(ssn, symbol, quantity);

				Vector portfolio = db.getPortfolio(ssn);
				showPortfolioList(portfolio);
			} catch (RecordNotFoundException rnfe) {
				System.out.println("BrokerGUI.actionPerformed() : " + rnfe);
				System.out.println("ش   ʽϴ. ֽ   ϴ.");
				showErrorDialog("ش   ʽϴ. ֽ   ϴ.");
			} catch( RemoteException re){
				 re.printStackTrace();
			}

		} else if ( buttonName.equals("SELL") ) {
			String ssn = ssntf.getText().trim();
			String symbol = symboltf.getText().trim();
			int quantity = Integer.parseInt(quatf.getText().trim());

			try {
				db.sellShares(ssn, symbol, quantity);

				Vector portfolio = db.getPortfolio(ssn);
				showPortfolioList(portfolio);
			} catch (RecordNotFoundException rnfe) {
				System.out.println("BrokerGUI.actionPerformed() : " + rnfe);
				System.out.println("ش   ʽϴ. ֽ Ű  ϴ.");
				showErrorDialog("ش   ʽϴ. ֽ Ű  ϴ.");
			} catch (InvalidTransactionException ite) {
				System.out.println("BrokerGUI.actionPerformed() : " + ite);
				System.out.println("ֽ ϰ  ʰų, Űϰ ϴ  ϴ.");
				showErrorDialog("ֽ ϰ  ʰų, Űϰ ϴ  ϴ.");
			} catch( RemoteException re){
				 re.printStackTrace();
			}

		} else if ( buttonName.equals("Stock Price") ) {
			String symbol = stocktf.getText().trim();
			float price = Float.parseFloat(pricetf.getText().trim());

			try {
				db.updateStockPrice(symbol, price);
			} catch (RecordNotFoundException rnfe) {
				System.out.println("BrokerGUI.actionPerformed() : " + rnfe);
				System.out.println("ش ֽ   ʽϴ.");
				showErrorDialog("ش ֽ   ʽϴ.");
			} catch( RemoteException re){
				 re.printStackTrace();
			}

			showStockList();
		//  ̾˷α OK 
		} else if ( buttonName.equals("OK") ) {
			errorDialog.dispose();
		}
	}

	// Ʈ  ý(  Ǿ )
	public void itemStateChanged(ItemEvent ie) {
		if ( ie.getSource() == cuslist ) {
			String ssn, name, address;

			String selectedItem = cuslist.getSelectedItem();
			st = new StringTokenizer(selectedItem);
			ssn = st.nextToken().trim();
			name = st.nextToken().trim();
			address = st.nextToken().trim();
System.out.println( ssn + " " + name + " " + address);
			ssntf.setText(ssn);
			nametf.setText(name);
			addressta.setText(address);

			try {
				Vector portpolio = db.getPortfolio(ssn);
				showPortfolioList(portpolio);
			} catch(RecordNotFoundException rnfe) {
				System.out.println("BrokerGUI.itemStateChanged() : " + rnfe);
				System.out.println("ش   ʽϴ.");
				showErrorDialog("ش   ʽϴ.");
			} catch( RemoteException re){
				 re.printStackTrace();
			}
		} else if ( ie.getSource() == portlist ) {
			String symbol, quantity;

			String selectedItem = portlist.getSelectedItem();
			st = new StringTokenizer(selectedItem);
			symbol = st.nextToken();
			quantity = st.nextToken();

			symboltf.setText(symbol);
			quatf.setText(quantity);
		} else if ( ie.getSource() == stocklist) {
			String symbol, priceStr= "";
			float price;

			String selectedItem = stocklist.getSelectedItem();
			st = new StringTokenizer(selectedItem);
			symbol = st.nextToken();
			try {
				price = db.getStockPrice(symbol);
				priceStr = price + "";
			} catch (RecordNotFoundException rnfe) {
				System.out.println("BrokerGUI.itemStateChanged() : " + rnfe);
				System.out.println("ش ֽ   ʽϴ.");
				showErrorDialog("ش ֽ   ʽϴ.");
			} catch( RemoteException re){
				 re.printStackTrace();
			}

			stocktf.setText(symbol);
			pricetf.setText(priceStr);
			symboltf.setText(symbol);
		}
	}

	// ADD, DELETE, UPDATE, VIEW  IMPLE, CANCEL  Enabled Setting	
	private void buttonEnabled(boolean isOn) {
		addb.setEnabled(isOn);
		deleteb.setEnabled(isOn);
		updateb.setEnabled(isOn);
		viewb.setEnabled(isOn);
		impleb.setEnabled(!isOn);
		cancelb.setEnabled(!isOn);
	}

	// TextField  
	private void emptyText() {
		nametf.setText("");
		ssntf.setText("");
		addressta.setText("");
	}

	// TextField Enabled Setting
	private void textEnabled(boolean isOn) {
		nametf.setEnabled(isOn);
		ssntf.setEnabled(isOn);
		addressta.setEnabled(isOn);
	}

	// CustList 
	private void showCustomerList() {
		cuslist.removeAll();
 try{
		String ssn, name, address;
		CustomerRec [] customers = db.getAllCustomers();

		for (int i=0; i < customers.length; i++) {
			ssn = customers[i].getSSN();
			name = customers[i].getName();
			address = customers[i].getAddr();

			cuslist.add(ssn + " " + name + " " + address);
		}

 }catch(RemoteException re){
		re.printStackTrace();
 }
	}

	// StockList 
	private void showStockList() {

	try{
		stocklist.removeAll();

		String symbol;
		float price;
		StockRec [] stocks = db.getAllStocks();

		for (int i=0; i < stocks.length; i++) {
			symbol = stocks[i].getSymbol();
			price = stocks[i].getPrice();

			stocklist.add(symbol + " " + price);
		}

	}catch(RemoteException re){
		 re.printStackTrace();
	}
	}

	//  ֽ Ʈ(PortList) 
	private void showPortfolioList(Vector portfolio) {
		portlist.removeAll();

		String symbol;
		int quantity;

		for (int i=0; i < portfolio.size(); i++) {
			SharesRec sr = (SharesRec)portfolio.get(i);

			symbol = sr.getSymbol();
			quantity = sr.getQuantity();

			portlist.add(symbol + " " + quantity);
		}
	}

	//  ߰ϱ
	private void addCustomer() {
		String ssn = ssntf.getText().trim();
		String name = nametf.getText().trim();
		String address = addressta.getText().trim();

		try {
			db.addCustomer(ssn, name, address);
		} catch (DuplicateIDException dide) {
			System.out.println("BrokerGUI.addCustomer() : " + dide);
			System.out.println("̹ ϵ Դϴ.");
			showErrorDialog("̹ ϵ Դϴ.");
		} catch( RemoteException re){
				 re.printStackTrace();
			}
	}

	//  ϱ
	private void deleteCustomer() {
		String ssn = ssntf.getText().trim();
			System.out.println("BrokerGUI.deleteCustomer@@@@@@@@@@@@@");

		try {

			db.deleteCustomer(ssn);
			System.out.println("BrokerGUI.deleteCustomer###############");
		} catch (RecordNotFoundException rnfe) {
			System.out.println("BrokerGUI.delete() : " + rnfe);
			System.out.println("ش   ʽϴ.");
			showErrorDialog("ش   ʽϴ.");
		} catch( RemoteException re){
				 re.printStackTrace();
			}

		portlist.removeAll();
	}

	//  ϱ
	private void updateCustomer() {
		String ssn = ssntf.getText().trim();
		String name = nametf.getText().trim();
		String address = addressta.getText().trim();

		try {
			db.updateCustomer(ssn, name, address);
		} catch (RecordNotFoundException rnfe) {
			System.out.println("BrokerGUI.updateCustomer() : " + rnfe);
			System.out.println("ش   ʽϴ.");
			showErrorDialog("ش   ʽϴ.");
		} catch( RemoteException re){
				 re.printStackTrace();
			}
	}

	// ֽ ϱ
	private void buyStocks() {
		String ssn = ssntf.getText().trim();
		String symbol = symboltf.getText().trim();
		int quantity = Integer.parseInt(quatf.getText().trim());

		try {
			db.buyShares(ssn, symbol, quantity);
		} catch (RecordNotFoundException rnfe) {
			System.out.println("BrokerGUI.buyStocks() : " + rnfe);
			System.out.println("ش   ʽϴ. ֽ   ϴ.");
			showErrorDialog("ش   ʽϴ.  ֽ   ϴ.");
		} catch( RemoteException re){
				 re.printStackTrace();
			}
	}

	// ֽ Űϱ
	private void sellStocks() {
		String ssn = ssntf.getText().trim();
		String symbol = symboltf.getText().trim();
		int quantity = Integer.parseInt(quatf.getText().trim());

		try {
			db.sellShares(ssn, symbol,quantity);
		} catch (RecordNotFoundException rnfe) {
			System.out.println("BrokerGUI.sellStocks() : " + rnfe);
			System.out.println("ش   ʽϴ. ֽ Ű  ϴ.");
			showErrorDialog("ش   ʽϴ. ֽ Ű  ϴ.");
		} catch (InvalidTransactionException ite) {
			System.out.println("BrokerGUI.sellStocks() : " + ite);
				System.out.println("ֽ ϰ  ʰų, Űϰ ϴ  ϴ.");
				showErrorDialog("ֽ ϰ  ʰų, Űϰ ϴ  ϴ.");
		} catch( RemoteException re){
				 re.printStackTrace();
			}
	}

	//  ݵ StockList  ϴ Thread run()
	// ---

	public static void main(String [] args) throws ClassNotFoundException, SQLException {
		BrokerGUI brgui = new BrokerGUI();
	}
}