/*
 * @(#)SharesRec.java	0.1 96/05/07 Tom McGinn
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  SUN
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */

//package broker.database;

import java.io.Serializable;

// The SharesRec class
// Stores a single instance of a Shares record
//
// These are dynamic objects that belong to customers
public class SharesRec implements Serializable {

	private String ssn;
	private String symbol;
	private int quantity;

	// SharesRec constructor
	public SharesRec (String ssn, String symbol, int quantity) {
		this.ssn = ssn;
		this.symbol = symbol;
		this.quantity = quantity;
	}

	public SharesRec (String ssn) {
		this (ssn, "", 0);
	}

	public SharesRec () {
		this ("", "", 0);
	}

	// Accessor methods
	public String getSSN () {
		return ssn;
	}

	public String getSymbol () {
		return symbol;
	}

	public int getQuantity () {
		return quantity;
	}

	// Mutator methods - note no setSSN method

	public void setSymbol (String newSymbol) {
		symbol = newSymbol;
	}

	public void setQuantity (int newQuantity) {
		quantity = newQuantity;
	}
}