/*
 * @(#)StockRec.java	0.1 96/05/07 Tom McGinn
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  SUN
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */

//package broker.database;

import java.io.Serializable;

// The StockRec class
// Keeps a single record instance of a stock object
//
// These are created from a dynamic query against the DB
public class StockRec implements Serializable {

	private String symbol;
	private float price;

	// StockRec constructor - create a instance of a stock
	// from the queried data
	public StockRec (String symbol, float price) {
		this.symbol = symbol;
		this.price = price;
	}
	
	// StockRec constructor - create a instance of a stock
	// with no data
	public StockRec () {
		symbol = "";
		price = 0.0f;
	}

	// Methods to return the private values of this object
	public float getPrice () {
		return price;
	}

	public String getSymbol () {
		return symbol;
	}

	public void setPrice (float newPrice) {
		price = newPrice;
	}

	public void printPrice () {
		System.out.print(price);
	}

	public void printStock () {
		System.out.print(symbol);
	}
}